/*
** Answers v1.0
**
** A WWW answers index
**
** Copyright (c) 5.5.94 by Andreas Ley <ley@rz.uni-karlsruhe.de>
**
** Permission to use, copy, modify, and distribute this software for any
** purpose and without fee is hereby granted, provided that the above
** copyright notice appears in all copies. This software is provided "as is"
** and without any express or implied warranties.
**
** This program has been tested on a HP9000/720 with HP-UX A.08.07
** In this environment, neither lint -u nor gcc -Wall produce any messages.
** If you encounter any errors or need to make any changes to port it
** to another platform, please contact me.
**
** Version history
**
** Version 1.0 - 5.5.94
**	Initial version
*/

char header[]="answers v1.0\n(c) 1994 by Andreas Ley\n";

/* General definitions */

#define	MASTER	"webmaster@rz.uni-karlsruhe.de"
#define	REFERENCE	"<A HREF=\"/~Andreas.Ley/\"><EM>Andreas Ley</EM></A>"

/* File locations */

#define	ROOT	"/usr/local/etc/httpd/lib/answers"

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <regex.h>
#include "answers_german.h"

#ifdef NEEDSTRERROR
extern int	sys_nerr;
extern char	*sys_errlist[];
#define	strerror(errno)	((errno)>=sys_nerr?"Undefined error":sys_errlist[errno])
#endif /* NEEDSTRERROR */

#define	FALSE	0		/* This is the naked Truth */
#define	TRUE	1		/* and this is the Light */


struct entry {
	struct entry	*next;
	char		*url;
	unsigned long	size;
	char		*subject;
	char		*keywords;
	};


/* Global variables */

char	root[]=ROOT;
char	master[]=MASTER;
char	*script_name;
char	*path_info;

char	*entry[1024];
size_t	max;

char	*iso2din[256] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "\"", "#", "$", "%", "&", "'", 
	"(", ")", "*", "+", ",", "-", ".", "/", 
	"0", "1", "2", "3", "4", "5", "6", "7", 
	"8", "9", ":", ";", "<", "=", ">", "?", 
	"@", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "[", "\\", "]", "^", "_", 
	"`", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "{", "|", "}", "~", NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "c", "l", "c", "y", "|", "#", 
	NULL, "c", "a", "<", "-", "-", "r", "_", 
	"o", "+", "2", "3", NULL, "u", "p", ".", 
	NULL, "1", "o", ">", "1/4", "1/2", "3/4", "?", 
	"a", "a", "a", "a", "ae", "a", "ae", "c", 
	"e", "e", "e", "e", "i", "i", "i", "i", 
	"d", "n", "o", "o", "o", "o", "oe", "x", 
	"o", "u", "u", "u", "ue", "y", "p", "ss", 
	"a", "a", "a", "a", "ae", "a", "ae", "c", 
	"e", "e", "e", "e", "i", "i", "i", "i", 
	"d", "n", "o", "o", "o", "o", "oe", "/", 
	"o", "u", "u", "u", "ue", "y", "p", "y",
	};

char *iso2html[256]= {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, "\t", "\n", NULL, NULL, "\r", NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "\"", "#", "$", "%", "&amp;", "'", 
	"(", ")", "*", "+", ",", "-", ".", "/", 
	"0", "1", "2", "3", "4", "5", "6", "7", 
	"8", "9", ":", ";", "&lt;", "=", "&gt;", "?", 
	"@", "A", "B", "C", "D", "E", "F", "G", 
	"H", "I", "J", "K", "L", "M", "N", "O", 
	"P", "Q", "R", "S", "T", "U", "V", "W", 
	"X", "Y", "Z", "[", "\\", "]", "^", "_", 
	"`", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "{", "|", "}", "~", " ", 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!`", "cents", "pound", "(currency)", "yen", "|", "(sect)", 
	"\"", "(C)", "na.", "&lt;&lt;", "(neg)", "-", "(R)", "=", 
	"^o", "+-", "^2", "^3", "'", "mu", "(par)", "*", 
	",", "^1", "no.", "&gt;&gt;", "1/4", "1/2", "3/4", "?`", 
	"&Agrave;", "&Aacute;", "&Acirc;", "&Atilde;", "&Auml;", "&Aring;", "&AElig;", "&Ccedil;", 
	"&Egrave;", "&Eacute;", "&Ecirc;", "&Euml;", "&Igrave;", "&Iacute;", "&Icirc;", "&Iuml;", 
	"&ETH;", "&Ntilde;", "&Ograve;", "&Oacute;", "&Ocirc;", "&Otilde;", "&Ouml;", "x", 
	"&Oslash;", "&Ugrave;", "&Uacute;", "&Ucirc;", "&Uuml;", "&Yacute;", "&THORN;", "&szlig;", 
	"&agrave;", "&aacute;", "&acirc;", "&atilde;", "&auml;", "&aring;", "&aelig;", "&ccedil;", 
	"&egrave;", "&eacute;", "&ecirc;", "&euml;", "&igrave;", "&iacute;", "&icirc;", "&iuml;", 
	"&eth;", "&ntilde;", "&ograve;", "&oacute;", "&ocirc;", "&otilde;", "&ouml;", "/", 
	"&oslash;", "&ugrave;", "&uacute;", "&ucirc;", "&uuml;", "&yacute;", "&thorn;", "&yuml;", 
	};


/* Prints header of a HTML-Request */
void show_header(char *subtitle, char *description)
{
	(void)printf("Content-type: text/html\n\n");
	(void)printf("<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n");
	(void)printf("<HTML>\n");
	(void)printf("<HEAD>\n");
	(void)printf("<TITLE>%s%s%s</TITLE>\n",TITLE,subtitle?" - ":"",subtitle?subtitle:"");
	(void)printf("<LINK REV=\"made\" HREF=\"mailto:%s\">\n",MASTER);
	(void)printf("</HEAD>\n");
	(void)printf("<BODY>\n");
	(void)printf("<H1>%s</H1>\n",subtitle?subtitle:TITLE);
	if (description) {
		(void)printf(description,master);
		(void)printf("<P>\n");
	}
}



/* Prints trailer of a HTML-Request */
void show_trailer(int index)
{
	if (index) {
		(void)printf("<P>%s\n",FOOTER);
		(void)printf("<ISINDEX>\n");
	}
	else
		(void)printf("<P><HR>\n");
	(void)printf(DISCLAIMER,master);
	(void)printf("\n%s\n",REFERENCE);
	(void)printf("</BODY>\n");
	(void)printf("</HTML>\n");
}



/* Shows an error page, based on wrong user input */
void show_error(char *error)
{
	show_header(ERROR,error);
	show_trailer(FALSE);
	exit(0);
}



/* Shows an error page, based on internal misfunction */
void show_fatal(char *error)
{
	show_header(ERROR,error);
	(void)printf(ERROR_FATAL,master);
	(void)printf("<P>\n");
	show_trailer(FALSE);
	exit(0);
}



void stradd(char **dest, char *src)
{
	if (src)
		while (*src)
			*(*dest)++=*src++;
}



char *din(char *src)
{
	static char	buffer[BUFSIZ];
	char		*dest;

	dest=buffer;
	while (*src)
		stradd(&dest,iso2din[(unsigned char)*src++]);
	*dest='\0';
	return(buffer);
}



char *htmlconv(src)
char	*src;
{
	static char	buffer[BUFSIZ];
	char		*dest;

	dest=buffer;
	while (*src)
		stradd(&dest,iso2html[(unsigned char)*src++]);
	*dest='\0';
	return(buffer);
}



/* Displays the main menu */
void main_menu()
{
	int	cnt;
	FILE	*src;
	char	title[BUFSIZ],buffer[BUFSIZ];

	show_header(NULL,MAIN_MENU_HEADER);
	for (cnt=0;cnt<max;cnt++) {
		src=fopen(entry[cnt],"r");
		(void)fgets(title,sizeof(title),src);
		(void)fgets(buffer,sizeof(buffer),src);
		if (feof(src))
			(void)printf("%s<BR>\n",title);
		else
			(void)printf("<A HREF=\"%s/%s\">%s</A><BR>\n",script_name,entry[cnt],title);
		(void)fclose(src);
	}
	show_trailer(TRUE);
}



/* Process search request */
void search(int cnt, char *pat[], char *fname, struct entry ***list)
{
	FILE	*src;
	char	line[BUFSIZ],*size,*subject,*keywords,*ptr;
	int	i;

	if ((src=fopen(fname,"r"))) {
		while(fgets(line,sizeof(line),src)) {
			size=strchr(line,'\t');
			*size++='\0';
			subject=strchr(size,'\t');
			*subject++='\0';
			if ((keywords=strchr(subject,'\t')))
				*keywords++='\0';
			ptr=din(subject);
			for (i=1;i<cnt;i++)
				if (!strstr(ptr,pat[i]))
					break;
			if (i<cnt)
				continue;
			**list=(struct entry *)malloc(sizeof(struct entry));
			(**list)->next=NULL;
			(**list)->url=strdup(line);
			(**list)->size=atol(size);
			(**list)->subject=strdup(subject);
			(**list)->keywords=keywords?strdup(keywords):NULL;
			*list=&(**list)->next;
		}
		(void)fclose(src);
	}
}



void show(struct entry *ptr)
{
	for (;ptr;ptr=ptr->next) {
		printf("<A HREF=\"%s\">%s</A>",ptr->url,htmlconv(ptr->subject));
		if (ptr->size>0)
			if (ptr->size>1073741824)
				printf ("(%ld G)",(ptr->size+1073741823)/1073741824);
			else if (ptr->size>=1048576)
				printf ("(%ld M)",(ptr->size+1048575)/1048576);
			else if (ptr->size>1024)
				printf ("(%ld K)",(ptr->size+1023)/1024);
			else
				printf ("(%ld Bytes)",ptr->size);
		printf("<BR>\n");
	}
}



int strptrcmp(const void *s1, const void *s2)
{
	return(strcmp(*(char **)s1,*(char **)s2));
}



void usage(char *image)
{
	(void)fprintf(stderr,"Usage: %s [-h] [-v]\n",image);
	exit(1);
}


int main(int argc, char *argv[])
{
	int		c;
	DIR		*dir;
	struct dirent	*dp;
	char		buffer[BUFSIZ],*query_string,*ptr,*qry;
	struct entry	*list,**listptr;
	int		i;

	while ((c=getopt(argc,argv,"vh?")) != EOF)
		switch ((char)c) {
		case 'v':
			(void)fprintf(stderr,header);
			exit(0);
		case 'h':
			(void)fprintf(stderr,header);
		case '?':
			usage(argv[0]);
		}

	(void)chdir(root);
	script_name=getenv("SCRIPT_NAME");
	query_string=getenv("QUERY_STRING");

	ptr=buffer;
	qry=query_string;

	if (argc<=1)
		main_menu();
	else {
		if ((dir=opendir("."))) {
			list=NULL;
			listptr=&list;
			for (i=1;i<argc;i++)
				argv[i]=strdup(din(argv[i]));
			while ((dp=readdir(dir)))
				if (dp->d_name[0]!='.')
					search(argc,argv,dp->d_name,&listptr);
			(void)closedir(dir);
			show_header(NULL,SEARCH_HEADER);
			printf("%s <CODE>",SEARCH_QUERY);
			for (i=1;i<argc;i++)
				printf("%s ",argv[i]);
			printf("</CODE><P>\n");
			if (list) {
				printf("%s<P>\n",SEARCH_FOUND);
				show(list);
			}
			else
				printf("%s<P>\n",SEARCH_EMPTY);
			show_trailer(TRUE);
		}
		else
			show_fatal(ERROR_DIRECTORY);
	}
	return(0);
}
